import "core-js/modules/es7.object.get-own-property-descriptors";
import "core-js/modules/es6.symbol";
import "core-js/modules/web.dom.iterable";
import "core-js/modules/es6.array.iterator";
import "core-js/modules/es6.object.to-string";
import "core-js/modules/es6.object.keys";
import "core-js/modules/es6.object.assign";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import * as React from "react";
import MonacoEditor from "@simgenius/react-monaco-editor-amd";
import AtomOneLightTheme from "./AtomLightTheme";
import localforage from "localforage";

var Babel = require("@babel/standalone");

var reactPreset = require("@babel/preset-react");

var envPreset = require("@babel/preset-env"); // 配置本地缓存


localforage.config({
  name: "Editor-Source" // 数据库名称

});

var Editor =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Editor, _React$Component);

  function Editor() {
    var _this;

    _classCallCheck(this, Editor);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Editor).apply(this, arguments));

    _this.editorDidMount = function (editor, monaco) {
      monaco.editor.defineTheme("atom-one-light", AtomOneLightTheme);
      monaco.editor.setTheme(_this.props.theme);
      editor.focus();
      _this.props.editorDidMount && _this.props.editorDidMount(editor, monaco);
    };

    _this.handleChange = function (newValue, e) {
      var _this$props = _this.props,
          language = _this$props.language,
          onChange = _this$props.onChange,
          storageKey = _this$props.storageKey;

      if (storageKey) {
        // 本地缓存
        localforage.setItem(storageKey, newValue);
      }

      if (language === "javascript") {
        try {
          var transformedCode = Babel.transform(newValue, {
            presets: [reactPreset, envPreset]
          }).code;
          onChange && onChange({
            source: newValue,
            transformed: transformedCode
          });
        } catch (e) {
          console.error(e);
        }
      } else {
        onChange && onChange({
          source: newValue,
          transformed: ""
        });
      }
    };

    return _this;
  }

  _createClass(Editor, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          onChange = _this$props2.onChange,
          editorDidMount = _this$props2.editorDidMount,
          _this$props2$options = _this$props2.options,
          options = _this$props2$options === void 0 ? {} : _this$props2$options,
          storageKey = _this$props2.storageKey,
          rest = _objectWithoutProperties(_this$props2, ["onChange", "editorDidMount", "options", "storageKey"]);

      var defaultOptions = _objectSpread({
        selectOnLineNumbers: true,
        fontSize: 16,
        fontFamily: "monospace",
        minimap: {
          enabled: false
        },
        lineNumbersMinChars: 2
      }, options);

      return React.createElement("div", {
        className: "editor"
      }, React.createElement(MonacoEditor, Object.assign({}, rest, {
        options: defaultOptions,
        onChange: this.handleChange,
        editorDidMount: this.editorDidMount
      })));
    }
  }]);

  return Editor;
}(React.Component);

export { Editor as default };